//-------at_LR----------------------
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 OrangeRed
#property indicator_width1 2
#property indicator_width2 2
//-----------------------------
extern int hrLR=36;
extern int d=0;
extern int i0=0;
extern bool SPR=false;
//------------------
double lr[],lrL[];
double sx,sy,syp,sxy,sxyp,sxx,aa,bb,S,di,spr2;
int p,ti,fs;
//********************************************************************
int init() 
{
   SetIndexBuffer(0,lr);
   SetIndexBuffer(1,lrL); SetIndexEmptyValue(1,0.0);
   return(0); 
}
//********************************************************************
int start()
{
   int cbi,IC=Bars-IndicatorCounted()-1;
   if (IC<20) cbi=IC; else 
   {
      if (SPR) spr2=MarketInfo(Symbol(),MODE_SPREAD)*Point/2; else spr2=0.0;
      //--------------------
      p=hrLR*60.0/Period()+1; if (p<3) p=3; 
      cbi=Bars-p-1-i0;
      
      sx=0.0; sxx=0.0; 
      for (int j=0; j<p; j++) {sx+=j; sxx+=j*j;} 
      S=sx*sx-p*sxx;
      
      syp=0.0; sxy=0.0;
      for (j=1; j<p; j++) {syp+=Close[j+cbi+i0]; sxy+=j*Close[j+cbi+i0];}
      
      di=d*Point;
      ti=Time[cbi];
   }
   //------------------------------ 
   for(int i=cbi; i>=0; i--) 
   { 
      if (ti!=Time[i]) 
      {
         sxy+=syp+Close[i+1+i0]-p*Close[i+p+i0];
         syp+=Close[i+1+i0]-Close[i+p+i0]; 
         ti=Time[i];
      }
      sy=syp+Close[i+i0]; 
      
      aa=(sx*sy-p*sxy)/S; 
      bb=(sy-aa*sx)/p;
      
      lr[i]=bb; 
      
      if (SPR) lr[i]+=spr2;
      if (d>0 && MathAbs(lr[i]-lr[i+1])<di) lr[i]=lr[i+1];
   
      if (lr[i]>lr[i+1]) fs=1;
      if (lr[i]<lr[i+1]) {if (fs==1) lrL[i+1]=lr[i+1]; fs=2;}
      
      if (fs==2) lrL[i]=lr[i]; else lrL[i]=0.0; 
   }
   //--------------------------------------------
   return(0);
}
//********************************************************************